BDOS	equ	5
TPA	equ	100H
	maclib cpm3

;	org	TPA

	jmp	main

?pchar:				;print char in A
	push	d
	push	b
	push	h
	mov	e,a
	mvi	c,2		;Console Output
	call	BDOS
	pop	h
	pop	b
	pop	d
	ret
	
?cono:	push	a
	mov	a,c
	call	?pchar
	pop	a
	ret
	
			
?pmsg:				;print text in hl, end with 0
	push	a
?pmsg1
        mov	a,m		; LD A,(HL)
	ora	a		; zero
	jz	pmend		; then stop
	call	?pchar
	inx	h		; INC HL
	jmp	?pmsg1
pmend	pop	a
	ret

stop:	mvi	c,0
	call	BDOS

start$msg:	db	'Test started',13,10,0

main:	

;	lxi	h,start$msg	; LD HL,start$msg
;	call	?pmsg
;	mvi	a,0
;	call	show$disk$type
;	mvi	a,1
;	call	show$disk$type
;	mvi	a,2
;	call	show$disk$type
	call	show$dph
	jmp	stop

@rdrv:	db	1		;0=A, 1=B...

show$msg2:	db	': Format ',0

show$disk$type:			;AD: A is the format number
	push	a
	push	h
	push	b
	push	d
	push	a
	lda	@rdrv
	adi	'A'
	mov	c,a
	call	?cono
	pop	a

	push	a
	lxi	h,show$msg2
	call	?pmsg
	pop	a
	push	a
	mov	l,a
	mvi	h,0
	call	?pdec
	mvi	c,','
	call	?cono
	mvi	c,' '
	call	?cono
	pop	a

	add	a		; * 2 = offset in pointer table
	lxi	h,DISK$TXT	; hl=pointer table
	mov	c,a
	mvi	b,0
	dad	b		; add hl,bc, BC points to table entry
	MOV	E,M		; LD E,(HL)
	INX	H
	MOV	D,M		; LD D,(HL)
	XCHG			; EX DE,HL 
	call	?pmsg		; show new format text

	lxi	h,DPTXT
	call	?pmsg
	pop	d
	pop	b
	pop	h
	pop	a
	ret

DISK$TXT:
	DW	DP8S0TX		; Format Description Text
	DW	DP8D3TX
	DW	DP8D1ATX
	DW	DP8D2ATX
	DW	DP8D3ATX
	DW	DP8D4TX
	DW	DP5D1TX
	DW	DP5D2TX
	DW	DP5D2ATX
	DW	DP5D3ATX
	DW	DP5D4TX
	DW	DP5D4ATX
	DW	DP5D5TX

DPTXT:		DB	' erkannt',13,10,0
DP8S0TX:	DB	'77 MAXI SS SD 26/128',0
DP8D3TX:	DB	'77 MAXI DS DD 8/1024',0
DP8D1ATX:	DB	'77 MAXI DS DD 26/256',0
DP8D2ATX:	DB	'77 MAXI SS DD 26/256',0
DP8D3ATX:	DB	'77 MAXI DS DD 8/1024',0
DP8D4TX:	DB	'80 MAXI DS DD 18/512 - CPM/86 1,44MB Skew2',0
DP5D1TX:	DB	'40 SS DD 16/256',0
DP5D2TX:	DB	'40 SS DD 5/1024',0
DP5D2ATX:	DB	'40 SS DD 10/512 Skew2',0
DP5D3ATX:	DB	'80 DS DD 10/512 Skew2 Prof',0
DP5D4TX:	DB	'Vortex DS DD',0
DP5D4ATX:	DB	'MSDOS',0
DP5D5TX:	DB	'MZ-8.xx',0

?pdec:		; print binary number 0-65535 from <HL>
	lxi b,table10! lxi d,-10000
next:
	mvi a,'0'-1
pdecl:
	push h! inr a! dad d! jnc stoploop
	inx sp! inx sp! jmp pdecl
stoploop:
	push d! push b
	mov c,a! call ?cono
	pop b! pop d
nextdigit:
	pop h
	ldax b! mov e,a! inx b
	ldax b! mov d,a! inx b
	mov a,e! ora d! jnz next
	ret

table10:
	dw	-1000,-100,-10,-1,0



;-----------------------------------------------------------------------------------

myDPB	dw	1	; spt
	db	2	; bsh
	db	3	; blm
	db	4	; exm
	dw	5	; dsm
	dw	6	; drm
	db	7	; al0
	db	8	; al1
	dw	9	; chs
	dw	10	; off
	db	11	; psh
	db	12	; phm


myDPH:	dw	0	; xlt
	db	0,0,0,0,0,0,0,0,0
	db	0	; mf
	dw	myDPB	; dpb
	dw	0	; csv
	dw	0	; alv
	dw	0	; dirbcb
	dw	0	; dtabcw
	dw	0	; hash
	dw	0	; hbank

PRVAL:
	;WANDELT INTEGER IN A (RANGE 0-F)
        ;IN ASCII ZEICHEN (REG. C)
	ANI	0FH     ;LOESCHE OBERE 4 BITS
	CPI	0AH	;A-F?
        JNC     PRVAL1  ;JA
        ADI     30H     ;0-9 => ADDIERE 30H DAZU
        MOV     C,A  
        RET
PRVAL1  ADI     37H     ;A-F => ADDIERE 37H DAZU
	MOV	C,A
        RET

	
?phex:
	;GIBT AKKU INHALT ALS HEXZAHL AUS
	PUSH	H
	PUSH	B	;RETTE BC REG
        PUSH    PSW
        RRC
        RRC
        RRC
        RRC
        ANI	0FH	;OBERE ZIFFER 0
        CALL    PRVAL   ;WANDLE NACH ASCII
        CALL    ?cono   ;GEBE ZEICHEN AUS
        POP     PSW     ;HOLE ORG. BYTE
        ANI     0FH
        CALL    PRVAL
        CALL    ?cono
        POP     B	;RESTORE BC
	POP	H
        RET

?phexw:	; HL als hex ausgeben
	PUSH	A
	MOV	A,H
	CALL	?phex
	MOV	A,L
	CALL	?phex
	POP	A
	RET

?comma: PUSH	B
	MVI	C,','
	CALL	?cono
	POP	B
	RET


show$dph16:
	MOV	E,M	; SPT
	INX	H
	MOV	D,M
	XCHG
	CALL	?phexw
	XCHG
	CALL ?comma
	INX	H
	RET

show$dph8:
	MOV	A,M
	CALL	?phex
	CALL ?comma
	INX	H
	RET

; HL points to DPH -> +12 is add of DPB
show$dph:
;	CALL	getDPH	; in HL
	lxi h,fdsd0

	PUSH	H
	MVI	C,12
	MVI	B,0
	DAD	B	; ADD HL,BC
	MOV	E,M
	INX	H
	MOV	D,M	; ADDR of DPB in DE
	XCHG		; and now in HL

	call	show$dph16	; spt
	call	show$dph8	; bsh
	call	show$dph8	; blm
	call	show$dph8	; exm
	call	show$dph16	; dsm
	call	show$dph16	; drm
	call	show$dph8	; al0
	call	show$dph8	; al1
	call	show$dph16	; chs
	call	show$dph16	; off
	call	show$dph8	; psh
	call	show$dph8	; psm
	mvi	c,13 ! call ?cono
	mvi	c,10 ! call ?cono

	POP	H
	RET	



	MVI	A,0F0H
	call	?phex
	mvi	c,' '	
	call	?cono
	MVI	H,0F0H
	MVI	L,0FH
	call	?phexw
	ret

;-----------------------------------------

; 9 SELDSK, C=Drive, E=InitFlag
BIOSPB:	db 9		; BIOS function no.
	db 0		; A register contents
	dw 0		; BC register contents
	dw 0		; DE register contents
	dw 0		; HL register contents

getDPH:	mvi c,32H	; direct bios call
	lxi d,BIOSPB
	call 5
	ret

;----------------------------------------

    ; Extended Disk Parameter Headers (XPDHs)

	dw	0 ;fd$write
	dw	0 ;fd$read
	dw	0 ;fd$login
	dw	0 ;fd$init
	db	0,0		; relative drive zero
fdsd0	dph     skew8,dp8d3a,64,144

dp8d3a	dpb 1024,16,77,8192,256,2

skew8	skew	8,3,1
	skew1	8,3,1
